unit EffacerDemarrage;

// Cette unit permet de programmer un effacement d'un fichier en cours d'utilisation au prochain redmarrage de l'ordinateur,
// ainsi que d'annuler ventuellement cette programmation.
// Ces procdures sont compatibles de Windows 95  Vista.

interface

uses Windows, SysUtils, Classes;

procedure EffacerAuDemarrage(Fichier: TFileName);
procedure AnnulerEffacerAuDemarrage(Fichier: TFileName);

implementation

function ReadREG_MULTI_SZ(const CurrentKey: HKey; const Subkey, ValueName: string; Strings: TStrings): bool;
var valueType: DWORD;
    valueLen: DWORD;
    buffer: PChar;
    key: HKEY;
    i: integer;
    Chaine: string;
begin
     result:=false;
     Strings.Clear;
     try
        if RegOpenKeyEx(CurrentKey, PChar(Subkey), 0, KEY_READ, key) = ERROR_SUCCESS then
        begin
             SetLastError(RegQueryValueEx(key, PChar(ValueName), nil, @valueType, nil, @valueLen));
             if GetLastError = ERROR_SUCCESS then
             if valueType = REG_MULTI_SZ then
             begin
                  GetMem(buffer, valueLen);
                  try
                     RegQueryValueEx(key, PChar(ValueName), nil, nil, PBYTE(buffer), @valueLen);
                     Chaine:='';
                     for i:=0 To valueLen-2 Do
                     if buffer[i]=#0 Then
                     begin
                          if Chaine<>'' then Strings.Add(Chaine);
                          Chaine:='';
                     end
                     else Chaine:=Chaine+Buffer[i];
                     result:=true;
                  finally
                     FreeMem(buffer)
                  end
             end
        end;
     except
     end;
end;

function WriteREG_MULTI_SZ(const CurrentKey: HKey; const Subkey, ValueName: string; Strings: TStrings): bool;
var
  key: HKEY;
  i: integer;
  Chaine: string;
begin
     result:=false;
     try
        Chaine:=''; for i := 0 to Strings.Count - 1 do Chaine:=Chaine+Strings[i]+#0+#0;
        Chaine:=Chaine+#0;
        if RegOpenKeyEx(CurrentKey, PChar(Subkey), 0, KEY_WRITE, key) = ERROR_SUCCESS then
        try
           if RegSetValueEx(key, PChar(ValueName), 0, REG_MULTI_SZ, PChar(Chaine), length(Chaine)) = ERROR_SUCCESS then result:=true;
           RegCloseKey(Key);
        except
           RegCloseKey(Key);
        end;
     except
     end;
end;

function GetWindir: string;
const PathDelim  = '\';
var Dossier:array[0..MAX_PATH-1] of Char; 
    Tmp : String;
begin
  GetWindowsDirectory(Dossier,SizeOf(Dossier));
  Tmp := Dossier;
  if Copy(Tmp, length(Tmp), 1) <> PathDelim then Tmp:=Tmp+PathDelim;
  Result := Tmp; 
end;

function NomCourt(Fichier: TFileName): TFileName;
var Temp: array[0..MAX_PATH-1]of char;
begin
     GetShortPathName(PChar(Fichier),Temp,SizeOf(Temp));
     result:=String(Temp);
end;

const WININIT='Wininit.ini';
      SECTION='[rename]';
      NUL='NUL';

function IndexOf(Sl : TStringList ; s : String) : Integer;
var i : Integer;
    lFound : Boolean;
begin
     i := 0; lFound := False;
     while (i <= sl.count - 1) and (not lFound) do
          if UpperCase(sl.Strings[i]) = UpperCase( s ) then lFound := True else Inc(i);
     if lFound then Result := i else result := -1
end;

procedure EffacerAuDemarrage(Fichier: TFileName);
var L: TStringList;
    k: integer;
begin
     if FileExists(Fichier) then
     begin
          if LO(GetVersion)>=5 then MoveFileEx(PChar(Fichier), nil, MOVEFILE_DELAY_UNTIL_REBOOT)
          else
          begin
               L:=TStringList.Create;
               if FileExists(GetWindir+WININIT) then L.LoadFromFile(GetWindir+WININIT);
               k:=IndexOf(L, SECTION);
               if k<>-1 then L.Insert(k+1, NUL+'='+NomCourt(Fichier))
               else
               begin
                    L.Add(SECTION);
                    L.Add(NUL+'='+NomCourt(Fichier));
               end;
               L.SaveToFile(GetWinDir+WININIT);
               L.Free;
          end;
     end;
end;

procedure AnnulerEffacerAuDemarrage(Fichier: TFileName);
var L: TStringList;
    i: integer;
begin
     if FileExists(Fichier) then
     begin
          L:=TStringList.Create;
          if LO(GetVersion)>=5 then
          begin
               ReadREG_MULTI_SZ(HKEY_LOCAL_MACHINE, 'SYSTEM\CurrentControlSet\Control\Session Manager', 'PendingFileRenameOperations', L);
               repeat
                     i:=IndexOf(L,'\??\'+Fichier);
                     if i<>-1 then L.Delete(i);
               until i=-1;
               WriteREG_MULTI_SZ(HKEY_LOCAL_MACHINE, 'SYSTEM\CurrentControlSet\Control\Session Manager', 'PendingFileRenameOperations', L);
          end
          else
          begin
               if FileExists(GetWindir+WININIT) then L.LoadFromFile(GetWindir+WININIT);
               i:=IndexOf(L, SECTION);
               if i<>-1 then
               begin
                    Inc(i);
                    while (i<L.Count) and not ((Copy(L[i],1,1)='[') and (Copy(L[i],length(L[i]),1)=']')) do
                         if SameText(L[i], NUL+'='+NomCourt(Fichier)) then L.Delete(i) else Inc(i);
                    if (L.Count=1) and (SameText(L[0], SECTION)) then DeleteFile(GetWindir+WININIT)
                                                                 else L.SaveToFile(GetWindir+WININIT);
               end;
          end;
          L.Free;
     end;
end;

end.
