//*****************************************************************************************************************************
// Source originale disponible sur : http://rudy.mif.pg.gda.pl/~reichel/  modifie par Columbo 03-2007 (compatibilit Vista) //
// Seule l'unit User.pas est cense tre modifie                                                                           //
//*****************************************************************************************************************************
unit ShellViewUnit;

interface

uses
  Windows, ActiveX, ComObj, ShlObj, Graphics, Math, Classes;

//*****************************************************************************************************************************
//*****************************************************************************************************************************
// IExtractImage interface from shlobj.h
//*****************************************************************************************************************************
//*****************************************************************************************************************************
const
 IEIFLAG_ASYNC       = $0001;      // ask the extractor if it supports ASYNC extract (free threaded)
 IEIFLAG_CACHE       = $0002;      // returned from the extractor if it does NOT cache the thumbnail
 IEIFLAG_ASPECT      = $0004;      // passed to the extractor to beg it to render to the aspect ratio of the supplied rect
 IEIFLAG_OFFLINE     = $0008;      // if the extractor shouldn't hit the net to get any content neede for the rendering
 IEIFLAG_GLEAM       = $0010;      // does the image have a gleam ? this will be returned if it does
 IEIFLAG_SCREEN      = $0020;      // render as if for the screen  (this is exlusive with IEIFLAG_ASPECT )
 IEIFLAG_ORIGSIZE    = $0040;      // render to the approx size passed, but crop if neccessary
 IEIFLAG_NOSTAMP     = $0080;
 IEIFLAG_NOBORDER    = $0100;
 IEIFLAG_QUALITY     = $0200;      // Passed to the IExtractImage : Extract method to indicate that a higher quality image is requested

 {$EXTERNALSYM IID_IExtractImage}
const
  IID_IExtractImage: TGUID = (   D1:$BB2E617C; D2:$0920; D3:$11d1; D4:($9a, $0b, $00, $c0, $4f, $c2, $d6, $c1));
  SID_IExtractImage       = '{BB2E617C-0920-11d1-9A0B-00C04FC2D6C1}';
  SID_IQueryInfo          = '{00021500-0000-0000-C000-000000000046}';

type
  {$EXTERNALSYM IQueryInfo}
    IQueryInfo = interface(IUnknown)
      [SID_IQueryInfo]
      function GetInfoTip(dwFlags: DWORD; var ppwszTip: PWideChar): HResult; stdcall;
      function GetInfoFlags(out pdwFlags: DWORD): HResult; stdcall;
    end;

  {$EXTERNALSYM IExtractImage}
    IExtractImage = interface(IUnknown)
    [SID_IExtractImage]
    function GetLocation(pszPathBuffer:LPWSTR;
                              cch:DWORD;
                              out pdwPriority:DWORD;
                              const prgSize:windows.PSIZE;
                              dwRecClrDepth:DWORD;
                              out pdwFlags:DWORD):HResult;stdcall;



    function Extract(out phBmpThumbnail:HBITMAP):HResult;stdcall;
end;
//*****************************************************************************************************************************
//*****************************************************************************************************************************
//*****************************************************************************************************************************
//*****************************************************************************************************************************

type
  TShellView = class(TComObject, IPersistFile, IPersist, IExtractImage, IQueryInfo) // Retirer IExtractImage (pour les miniatures)
                                                                                    // ou IQueryInfo (pour les informations)
                                                                                    // pour dsactiver une option Shell
  private
    FFile:String;
    pMalloc: IMalloc;
    FSize:SIZE;
  protected
    function IsDirty: HResult; stdcall;
    function Load(pszFileName: POleStr; dwMode: Longint): HResult; stdcall;
    function Save(pszFileName: POleStr; fRemember: BOOL): HResult; stdcall;
    function SaveCompleted(pszFileName: POleStr): HResult; stdcall;
    function GetCurFile(out pszFileName: POleStr): HResult; stdcall;
    function GetClassID(out classID: TCLSID): HResult; stdcall;

    function GetLocation(pszPathBuffer:PWideChar;
                              cch:DWORD;
                              out pdwPriority:DWORD;
                              const prgSize:windows.PSIZE;
                              dwRecClrDepth:DWORD;
                              out pdwFlags:DWORD):HResult;stdcall;

    function Extract(out phBmpThumbnail:HBITMAP):HResult;stdcall;
    function GetInfoTip(dwFlags: DWORD; var ppwszTip: PWideChar): HResult; stdcall;
    function GetInfoFlags(out pdwFlags: DWORD): HResult; stdcall;
 public
    procedure  Initialize; override;
    destructor Destroy; override;
  end;

implementation

uses ComServ, SysUtils, Registry, User, EffacerDemarrage;

function IsWinNT : boolean;
begin
   result := ( Win32Platform = VER_PLATFORM_WIN32_NT );
end;

function IsAdmin: Boolean;
const
  SECURITY_NT_AUTHORITY: TSIDIdentifierAuthority = (Value: (0, 0, 0, 0, 0, 5));
  SECURITY_BUILTIN_DOMAIN_RID = $00000020; 
  DOMAIN_ALIAS_RID_ADMINS = $00000220; 
var 
  hAccessToken: THandle;
  ptgGroups: PTokenGroups;
  dwInfoBufferSize: DWORD;
  psidAdministrators: PSID;
  x: integer;
  bSuccess: BOOL;
begin
     if not IsWinNT then begin result:=true; exit; end;
  Result := false;
  bSuccess := OpenThreadToken(GetCurrentThread, TOKEN_QUERY, True,hAccessToken); 
  if not bSuccess then 
  begin
    if GetLastError = ERROR_NO_TOKEN then 
    bSuccess := OpenProcessToken(GetCurrentProcess, TOKEN_QUERY,hAccessToken); 
  end; 
  if bSuccess then 
  begin 
    GetMem(ptgGroups, 1024); 
    bSuccess := GetTokenInformation(hAccessToken, TokenGroups, 
    ptgGroups, 1024, dwInfoBufferSize); 
    CloseHandle(hAccessToken); 
    if bSuccess then 
    begin
      AllocateAndInitializeSid(SECURITY_NT_AUTHORITY, 2, SECURITY_BUILTIN_DOMAIN_RID, DOMAIN_ALIAS_RID_ADMINS, 0, 0, 0, 0, 0, 0, psidAdministrators);

      for x := 0 to ptgGroups.GroupCount - 1 do 
      if EqualSid(psidAdministrators, ptgGroups.Groups[x].Sid) then
      begin 
        Result := true; 
        break; 
      end;

      FreeSid(psidAdministrators); 
    end; 
    FreeMem(ptgGroups); 
  end; 
end;

function TShellView.GetInfoTip(dwFlags: DWORD; var ppwszTip: PWideChar): HResult;
var pMalloc:IMalloc;
    ToolTipS: string;
begin
     if (  SHGetMalloc ( pMalloc ) = E_FAIL ) then result := E_FAIL
     else
     try
        RecupererInfo(FFile, ToolTipS);
        ppwszTip := pMalloc.Alloc ( Length(ToolTipS)*SizeOf(WideChar) + 1);
        pMalloc._Release();
        StringToWideChar(ToolTipS,ppwszTip,Length(ToolTipS)*SizeOf(WideChar) + 1);
        result := S_OK;
     except result := E_FAIL;
     end;
end;

procedure TShellView.Initialize;
begin inherited; if Failed(ShGetMalloc(pMalloc)) then pMalloc := nil; end;

destructor TShellView.Destroy;
begin inherited; pMalloc := nil; end;

function TShellView.GetLocation(pszPathBuffer:LPWSTR; cch:DWORD; out pdwPriority:DWORD; const prgSize:windows.PSIZE; dwRecClrDepth:DWORD; out pdwFlags:DWORD):HResult;
begin
    FSize := prgSize^;
    if (pdwFlags and IEIFLAG_ASYNC) > 0 then result := E_PENDING
    else result := NOERROR;
end;

function TShellView.Extract(out phBmpThumbnail:HBITMAP):HResult;
var bmp:HBitmap;
    MemDC, DC:HDC;
    OldBmp:Thandle;
    Bitmap: TBitmap;
    k: single;
begin
     Bitmap:=TBitmap.Create;
     Bitmap.Width:=FSize.cx;
     Bitmap.Height:=FSize.cy;
     RecupererBitmap(FFile, Bitmap);
     try
        DC := GetDC(0);
        MemDC := CreateCompatibleDC(DC);
        bmp := CreateCompatibleBitmap(DC,Fsize.cx,FSize.cy);
        OldBmp := SelectObject(MemDC,Bmp);
        BitBlt(MemDC,0,0,Fsize.cx,FSize.cy,0,0,0,WHITENESS);
        if (Bitmap.Width<>0) and (Bitmap.Height<>0) then
        begin
             k:=min(FSize.cx/Bitmap.Width,FSize.cy/Bitmap.Height);
             StretchBlt(MemDC,
               (FSize.cx-Round(Bitmap.Width*k)) div 2,
               (FSize.cy-Round(Bitmap.Height*k)) div 2,
               Round(Bitmap.Width*k),
               Round(Bitmap.Height*k),
               Bitmap.Canvas.Handle,
               0,
               0,
               Bitmap.Width,
               Bitmap.Height,
               SRCCOPY);
             end;
        SelectObject(MemDC,OldBmp);
        phBmpThumbnail := bmp;
        DeleteDC(MemDC);
        ReleaseDC(0,DC);
     finally
     end;
     Bitmap.Free;
     result := NOERROR;
end;

function TShellView.IsDirty: HResult;
begin Result := E_NOTIMPL; end;

function TShellView.Load(pszFileName: POleStr; dwMode: Integer): HResult;
begin FFile  := pszFileName; Result := S_OK; end;

function TShellView.GetInfoFlags(out pdwFlags: DWORD): HResult;
begin Result := E_NOTIMPL; end;

function TShellView.Save(pszFileName: POleStr; fRemember: BOOL): HResult;
begin Result := E_NOTIMPL; end;

function TShellView.SaveCompleted(pszFileName: POleStr): HResult;
begin Result := E_NOTIMPL; end;

function TShellView.GetCurFile(out pszFileName: POleStr): HResult;
begin Result := E_NOTIMPL; end;

function TShellView.GetClassID(out classID: TCLSID): HResult;
begin Result := E_NOTIMPL; end;

type
  TShellViewFactory = class(TComObjectFactory)
  public
    procedure UpdateRegistry(Register: Boolean); override;
  end;

function Sto_GetModuleName: String;
var szFileName: array[0..MAX_PATH-1] of Char;
begin
     GetModuleFileName(hInstance, szFileName, MAX_PATH);
     Result := szFileName;
end;

procedure TShellViewFactory.UpdateRegistry(Register: Boolean);
var
  ClassID, Ext: string;
  K, V: TStringList;
begin
     if (not IsAdmin) or (Copy(Extension,1,1)<>'.') then exit;
     
     Ext:=Extension;
     with TRegistry.Create do
     try
        RootKey := HKEY_CLASSES_ROOT;
        if OpenKey(Ext, false) then Ext:=ReadString('') else exit;
     finally Free; end;

     ClassID := GUIDToString(Class_View);

     if Register then
     begin
          inherited UpdateRegistry(Register);
          with TRegistry.Create do
          try
             RootKey := HKEY_CLASSES_ROOT;
             OpenKey(Ext+'\shellex\'+SID_IExtractImage,True);
             WriteString('',ClassID);
             CloseKey;
             OpenKey(Ext+'\shellex\'+SID_IQueryInfo,True);
             WriteString('',ClassID);
             CloseKey;

             OpenKey(Ext+'\CLSID',True);
             WriteString('',ClassID);
             CloseKey;

             OpenKey('CLSID\'+ClassID+'\InprocServer32',True);
             WriteString('',Sto_GetModuleName);
             WriteString('ThreadingModel','Apartment');
             CloseKey;
          finally
             Free;
          end;
          if (Win32Platform = VER_PLATFORM_WIN32_NT) then
          with TRegistry.Create do
          try
             RootKey := HKEY_LOCAL_MACHINE;
             OpenKey('SOFTWARE\Microsoft\Windows\CurrentVersion\Shell Extensions\Approved', True);
             WriteString(ClassID, Description);
             CloseKey;

             if LO(Getversion)>=6 then
             begin
                  OpenKey('SOFTWARE\Microsoft\Windows\CurrentVersion\PropertySystem\PropertyHandlers\'+Extension, True);
                  WriteString('', ClassID);
                  CloseKey;
             end;
          finally
             Free;
          end;

          AnnulerEffacerAuDemarrage(Sto_GetModuleName); // Annuler toute ventuelle programmation d'effacement la DLL
                                                        // au prochain dmarrage de l'ordinateur
     end
     else
     begin
          with TRegistry.Create do
          try
             RootKey := HKEY_CLASSES_ROOT;
             DeleteKey('CLSID\'+ClassID+'\InprocServer32');
             DeleteKey(Ext+'\shellex\'+SID_IExtractImage);
             DeleteKey(Ext+'\shellex\'+SID_IQueryInfo);
             if OpenKey(Ext+'\shellex', false) then
             begin
                  K:=TStringList.Create;
                  GetKeyNames(K);
                  V:=TStringList.Create;
                  GetValueNames(V);
                  CloseKey;
                  if V.Count+K.Count=0 then DeleteKey(Ext+'\shellex');
             end;
             DeleteKey(Ext+'\CLSID');

             if (Win32Platform = VER_PLATFORM_WIN32_NT) then
             begin
                  RootKey := HKEY_LOCAL_MACHINE;
                  if OpenKey('SOFTWARE\Microsoft\Windows\CurrentVersion\Shell Extensions\Approved', True) then
                     DeleteValue(ClassID);
                  CloseKey;
                  if LO(Getversion)>=6 then
                  begin
                       if OpenKey('SOFTWARE\Microsoft\Windows\CurrentVersion\PropertySystem\PropertyHandlers\', True) then
                          DeleteKey(Extension);
                       CloseKey;
                  end;
             end;

          finally
             Free;
          end;
          inherited UpdateRegistry(Register);

          EffacerAuDemarrage(Sto_GetModuleName); // Programme un effacement de la DLL
                                                 // au prochain dmarrage de l'ordinateur
     end;
end;


initialization
  TShellViewFactory.Create(ComServer, TShellView, Class_View, '', Description, ciMultiInstance, tmApartment);
end.
